package demo.zusekopf;

import at.gv.zustellung.zkopf.ZuseKopfConstants;
import at.gv.zustellung.zkopf.client.BulkQueryClient;
import at.gv.zustellung.zkopf.config.PropertiesZuseKopfConfiguration;
import at.gv.zustellung.zkopf.xsd.zkopf.BulkQueryType;
import at.gv.zustellung.zkopf.xsd.zkopf.MessagingaddressType;
import at.gv.zustellung.zkopf.xsd.zkopf.QueryType;
import at.gv.zustellung.zkopf.xsd.zkopf_persondata.IdentificationType;
import at.gv.zustellung.zkopf.xsd.zkopf_persondata.IdentificationType.Value;
import at.gv.zustellung.zkopf.xsd.zkopf_persondata.InternetAddressType;
import at.gv.zustellung.zkopf.xsd.zkopf_persondata.PersonNameType;
import at.gv.zustellung.zkopf.xsd.zkopf_persondata.PersonNameType.FamilyName;
import at.gv.zustellung.zkopf.xsd.zkopf_persondata.PhysicalPersonType;

public class DemoBulkQuery {

	/**
	 * @param args
	 */
	public static void main(String[] args) throws Exception {
		
		String bulkQueryServiceURL = "https://zustellung.egiz.gv.at/zkopf-test/services/BulkQuery";
		BulkQueryType query = new BulkQueryType();
		
		// create query with physical person and demographic data
		QueryType q1 = new QueryType();
		q1.setID("0");
		PhysicalPersonType ppt = new PhysicalPersonType();
		PersonNameType pnt = new PersonNameType();
		pnt.setGivenName("Arne");
		FamilyName fnt = new FamilyName();
		fnt.setValue("Tauber");
		pnt.setFamilyName(fnt);
		ppt.setName(pnt);
		ppt.setDateOfBirth("1979-08-21");
		q1.setPhysicalPerson(ppt);
		MessagingaddressType mat = new MessagingaddressType();
		InternetAddressType iat = new InternetAddressType();
		iat.setAddress("arne.tauber@egiz.gv.at");
		mat.setInternetAddress(iat);
		q1.setVerAddress(mat);
		query.getQuery().add(q1);
		
		// create query with gvzbpk
		QueryType q2 = new QueryType();
		q2.setID("1");
		IdentificationType idt = new IdentificationType();
		idt.setType("urn:publicid:gv.at:ecdid+ZU");
		Value value = new Value();
		value.setValue("XYZ");
		idt.setValue(value);
		q2.setIdentification(idt);
		query.getQuery().add(q2);
		
		// create query with ERV code
		QueryType q3 = new QueryType();
		q3.setID("2");
		idt = new IdentificationType();
		idt.setType(ZuseKopfConstants.SOURCEPIN_TYPE_BULK_QUERY_XERV);
		value = new Value();
		value.setValue("P-12345");
		idt.setValue(value);
		q3.setIdentification(idt);
		query.getQuery().add(q3);
		
		// create query with source PIN
		QueryType q4 = new QueryType();
		q4.setID("3");
		idt = new IdentificationType();
		idt.setType(ZuseKopfConstants.SOURCEPIN_TYPE_BULK_QUERY_XFN);
		value = new Value();
		value.setValue("123456a");
		idt.setValue(value);
		q4.setIdentification(idt);
		query.getQuery().add(q4);
		
		// make bulk query
		PropertiesZuseKopfConfiguration propsConfig = new PropertiesZuseKopfConfiguration("sample-conf/zusekopf.properties");
		BulkQueryClient client = new BulkQueryClient(propsConfig);
		client.sendBulkQueryRequest(bulkQueryServiceURL, query);

	}

}
