package demo.zusekopf;

import java.io.FileInputStream;

import at.gv.zustellung.zkopf.client.PushClient;
import at.gv.zustellung.zkopf.config.PropertiesZuseKopfConfiguration;
import at.gv.zustellung.zkopf.xsd.zkopf.PushResponseType;
import at.gv.zustellung.zkopf.xsd.zkopf.PushResponseType.Error.FailedDN;

public class DemoPushRequest {

	public static void main(String[] args) throws Exception {
		// URL of Zustellkopf Push Service
		String zkopfServiceURL = "https://zustellung.egiz.gv.at/zkopf-test/services/PushService";
		
		// load zusekopf configuration
		PropertiesZuseKopfConfiguration propsConfig = new PropertiesZuseKopfConfiguration("sample-conf/zusekopf.properties");
		
		// create client
		PushClient client = new PushClient(propsConfig);
		
		// send push request
		PushResponseType response = client.push(zkopfServiceURL, new FileInputStream("sample-conf/push_add.ldif"));
		
		if (response.getSuccess() != null) {
			System.out.println("Push erfolgreich.");
		} else {
			if (response.getError().getCode() != null) {
				System.out.println("Allgemeiner Fehler: " + response.getError().getCode() + " / " + response.getError().getInfo());
			} else {
				for (FailedDN fdn : response.getError().getFailedDN()) {
					System.out.println("DN: " + fdn.getDN() + " / Fehler: " + fdn.getInfo());
				}
			}
		}
	}
	
}
